#ifndef POWERUP_H
#define POWERUP_H

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

#include "base.h"

class Level;

class Powerup {
public:
  Powerup();
  ~Powerup();
  
  /* initial position and speed vector. (Speed gets copied) */
  bool init(double x,double y,int *v,GLuint tex);

  double getX();
  double getY();
  /* This is actually a trick to know what sort of powerup this is */
  GLuint getTex();

  /* return true if the powerup should be removed */
  bool update(double t,Level *lvl);

  void render();

 private:

  GLuint tex;

  double x;
  double y;

  int v[2];
  double angle;

};

#endif
