#ifndef SERVER_H
#define SERVER_H

#include <string.h>

#include "item.h"

/* A breakout client/server implementation. The class name is
   misleading because it is used both by clients and servers. After
   creating the object, call listen() if you want to be a server, or
   connect() if you want to be a client.

   Copyright (C) 2010 Maxime Gamboni. See COPYING for
   copying/warranty info. */


#define PORT 1235
// port in a string, for use with getaddrinfo
#define SPORT "1235"

/* How many people may connect to this server */
#define PEERS 1

class Server {
 public:
  Server();
  ~Server();

  /* Starts listening. Returns false in case something went wrong */
  bool server();

  /* Connect to the remote breakout server. Returns false in case
     something went wrong */
  bool client(const char *addr);

  /* Wrapper for standard send() function. The first bytes should
     contain the object identifier item::get_id(). */
  void push(struct item_info *data,size_t len);

  /* Query for events from the clients */
  void poll();

 private:
  int sfd; // Local ("Server") socket file descriptor
  int cfd; // Remote ("Client") socket file descriptor, -1 as long as
	   // no one is connected
};

#endif
