#include "slash.h"

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

#include "main.h"

Slash::Slash(bool direction,unsigned int id) : Stone(id) {
  this->dr = direction;
}

Slash::~Slash() {
}

void Slash::init(char ch,int x,int y) {
  Stone::init(ch,x,y);
}

bool Slash::breakable() {
  return false;
}

bool Slash::trigger(Littlecube *b) {
  click[rand()%4].play();
  return false;
}

double Slash::check_collision(double x,double y,double dx,double dy, double *n, double *v,bool triggers) {
  int tx=this->getX();  int ty=this->getY();
  double d;
  if (dr) {
    /* the code below works only with '/' so if dr==1, flip everything
       along the y axis and proceed with /-code (shifting tx by one
       because a backslash is anchored at (tx+1,ty), not (tx,ty)). */
    x = -x;
    tx = -tx-1;
    dx = -dx;
  }

  d = wall_collision(y+x, y-x,
		     dy+dx, dy-dx,
		     ty+tx, ty+tx+2,
		     ty-tx);

  if (d!=2) {
    /* collision! */
    if (dx>dy) {
      //      printf("top left\n");
      n[0]=-HSQTWO; n[1]=+HSQTWO;
    } else { // dx<dy
      //      printf("bottom right\n");
      n[0]=+HSQTWO; n[1]=-HSQTWO;
    }
    if (dr) n[0] = -n[0]; // flip the normal back for '\'.
    v[0]=0; v[1]=0;
  }
  return d;
}


void Slash::render() {
  glColor3f(1,1,1);
  glPushMatrix(); {
    if (dr) {
      glTranslatef(getX()+0.95,getY(),0);
      glRotatef(135,0,0,1);
    } else {
      glTranslatef(getX(),getY(),0);
      glRotatef(45,0,0,1);
    }
    glTranslatef(0,-0.05,0);
    render_cube(SQTWO*0.95,0.1,0.5);
    glEnd();
  } glPopMatrix();
}

